vec4 diffuse,ambient,specular;
varying vec3 normal,lightDir,halfVector;
uniform sampler2D tex;
uniform sampler2DShadow shadowMap;
varying vec4 shadowCoords;

void main()
{
	vec3 n,halfV;
	float NdotL,NdotH;
	
	ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient;
	ambient += gl_LightModel.ambient * gl_FrontMaterial.ambient;
	
	vec4 color = ambient;
	
	n = normalize(normal);

	
	NdotL = max(dot(n,lightDir),0.0);

	if (NdotL > 0.0)
	{
		diffuse = (gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse) * NdotL;
		halfV = normalize(halfVector);
		NdotH = max(dot(n,halfV),0.0);
		specular = gl_FrontMaterial.specular * gl_LightSource[0].specular * pow(NdotH, gl_FrontMaterial.shininess);
		
		color += diffuse + specular;
	}

	vec4 texColor = texture2D(tex, gl_TexCoord[0].xy);

	float shadow = shadow2DProj(shadowMap, shadowCoords).r;
	if(shadow == 0.0)
		shadow = 0.2;
	gl_FragColor = mix(texColor,color,0.5) * shadow;
	gl_FragColor.a = texColor.a;

}